diff --git a/src/main/java/net/minecraft/core/item/SeedsItem.java b/src/main/java/net/minecraft/core/item/SeedsItem.java
index aa6f45789..1813b320b 100644
--- a/src/main/java/net/minecraft/core/item/SeedsItem.java
+++ b/src/main/java/net/minecraft/core/item/SeedsItem.java
@@ -3,11 +3,16 @@ package net.minecraft.core.item;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
+import java.util.Random;
+
 public class SeedsItem extends Item {
 	private int cropsId;
 
@@ -32,5 +37,14 @@ public class SeedsItem extends Item {
 		}
 		return false;
 	}
-
+	@Override
+	public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+		int x = blockX + direction.getOffsetX();
+		int y = blockY + direction.getOffsetY();
+		int z = blockZ + direction.getOffsetZ();
+		Block b = world.getBlock(x, y, z);
+		if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
+			onUseItemOnBlock(itemStack, null, world, x, y, z, direction.getSide(), 0.5, 0.5);
+		}
+	}
 }
diff --git a/src/main/java/net/minecraft/core/item/SnowballItem.java b/src/main/java/net/minecraft/core/item/SnowballItem.java
index 80f1c6ba1..e5f7028c0 100644
--- a/src/main/java/net/minecraft/core/item/SnowballItem.java
+++ b/src/main/java/net/minecraft/core/item/SnowballItem.java
@@ -1,18 +1,14 @@
 package net.minecraft.core.item;
 
-// Referenced classes of package net.minecraft.src:
-//            Item, ItemStack, World, SnowballProjectile,
-//            Player
-
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.SnowballProjectile;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class SnowballItem
-    extends Item
-    implements IDispensable
+public class SnowballItem extends Item implements IDispensable
 {
 
     public SnowballItem(String name, String namespaceId, int id)
@@ -34,9 +30,17 @@ public class SnowballItem
     }
 
     @Override
-    public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int zOffset, Random random) {
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        SnowballProjectile snowballProjectile = new SnowballProjectile(world, blockX + offX, blockY + offY, blockZ + offZ);
+        snowballProjectile.setHeading(direction.getOffsetX() * 0.6, direction.getOffsetY() == 0 ? 0.1 : direction.getOffsetY() * 0.6, direction.getOffsetZ() * 0.6f, 1.1F, 6F);
+        world.entityJoinedWorld(snowballProjectile);
+        itemStack.stackSize -= 1;
+    }
+
+    @Override
+    public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int yOffset, int zOffset, Random random) {
         SnowballProjectile entitysnowball = new SnowballProjectile(world, x, y, z);
-        entitysnowball.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
+        entitysnowball.setHeading(xOffset, yOffset + 0.1D, zOffset, 1.1F, 6F);
         world.entityJoinedWorld(entitysnowball);
     }
 }
diff --git a/src/main/java/net/minecraft/core/item/SpawnerWandItem.java b/src/main/java/net/minecraft/core/item/SpawnerWandItem.java
index 5f6bde1f5..5ee620f8d 100644
--- a/src/main/java/net/minecraft/core/item/SpawnerWandItem.java
+++ b/src/main/java/net/minecraft/core/item/SpawnerWandItem.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.item;
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
@@ -13,9 +15,7 @@ import net.minecraft.server.entity.player.ServerPlayer;
 
 import java.util.Random;
 
-public class SpawnerWandItem
-    extends Item
-    implements IDispensable
+public class SpawnerWandItem extends Item implements IDispensable
 {
     public SpawnerWandItem(String name, String namespaceId, int id) {
         super(name, namespaceId, id);
@@ -29,24 +29,8 @@ public class SpawnerWandItem
         }
 
         if (!player.isSneaking()){
-            float f = 1.0F;
-            float f1 = player.xRotO + (player.xRot - player.xRotO) * f;
-            float f2 = player.yRotO + (player.yRot - player.yRotO) * f;
-            double posX = player.xo + (player.x - player.xo) * (double) f;
-            float yOff = player instanceof ServerPlayer ? player.getHeightOffset() : 0;
-            double posY = (player.yo + (player.y - player.yo)) + yOff;
-            double posZ = player.zo + (player.z - player.zo) * (double) f;
-            Vec3 vec3 = Vec3.getTempVec3(posX, posY, posZ);
-            float f3 = MathHelper.cos(-f2 * 0.01745329F - MathHelper.PI);
-            float f4 = MathHelper.sin(-f2 * 0.01745329F - MathHelper.PI);
-            float f5 = -MathHelper.cos(-f1 * 0.01745329F);
-            float f6 = MathHelper.sin(-f1 * 0.01745329F);
-            float f7 = f4 * f5;
-            float f8 = f6;
-            float f9 = f3 * f5;
             double reachDistance = player.getGamemode().getBlockReachDistance();
-            Vec3 vec31 = vec3.add((double) f7 * reachDistance, (double) f8 * reachDistance, (double) f9 * reachDistance);
-            HitResult rayTraceResult = world.checkBlockCollisionBetweenPoints(vec3, vec31, false);
+            HitResult rayTraceResult = player.rayTrace(reachDistance, 1f, false, false);
 
             if (rayTraceResult != null){
                 if (!world.isClientSide){
@@ -79,13 +63,14 @@ public class SpawnerWandItem
             world.entityJoinedWorld(entity);
         }
     }
+
     @Override
-    public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int zOffset, Random random) {
-        spawnEntity(itemStack, world, x + xOffset * 0.5, y, z + zOffset * 0.5);
+    public void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int yOffset, int zOffset, Random random) {
+        spawnEntity(itemStack, world, x + xOffset * 0.5, y + yOffset * 0.5, z + zOffset * 0.5);
     }
 
     @Override
-    public boolean isRemovedOnDispense() {
-        return false;
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        spawnEntity(itemStack, world, blockX + offX + direction.getOffsetX() * 0.5, blockY + offY + direction.getOffsetY() * 0.5, blockZ + offZ + direction.getOffsetZ() * 0.5);
     }
 }
diff --git a/src/main/java/net/minecraft/core/item/ToolShearsItem.java b/src/main/java/net/minecraft/core/item/ToolShearsItem.java
index 811380791..851a813b9 100644
--- a/src/main/java/net/minecraft/core/item/ToolShearsItem.java
+++ b/src/main/java/net/minecraft/core/item/ToolShearsItem.java
@@ -6,11 +6,22 @@ package net.minecraft.core.item;
 //            Mob
 
 import net.minecraft.core.block.BaseLeavesBlock;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.SheepMob;
 import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+
+import java.util.List;
+import java.util.Random;
 
 public class ToolShearsItem extends Item
 {
@@ -46,4 +57,16 @@ public class ToolShearsItem extends Item
             return super.getStrVsBlock(itemstack, block);
         }
     }
+
+    @Override
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        blockX += direction.getOffsetX();
+        blockY += direction.getOffsetY();
+        blockZ += direction.getOffsetZ();
+        AABB box = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1, blockY + 1, blockZ + 1);
+        List<Entity> entities = world.getEntitiesWithinAABB(SheepMob.class, box);
+        if (!entities.isEmpty()) {
+            ((SheepMob)(entities.get(0))).onItemInteract(itemStack);
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/item/block/AlgaeBlockItem.java b/src/main/java/net/minecraft/core/item/block/AlgaeBlockItem.java
index 95871617b..bf4333752 100644
--- a/src/main/java/net/minecraft/core/item/block/AlgaeBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/AlgaeBlockItem.java
@@ -14,6 +14,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public class AlgaeBlockItem extends BlockItem
 {
@@ -26,20 +27,20 @@ public class AlgaeBlockItem extends BlockItem
     }
     
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
     	return false;
     }
     
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player player)
     {
         float f = 1.0F;
-        float f1 = entityplayer.xRotO + (entityplayer.xRot - entityplayer.xRotO) * f;
-        float f2 = entityplayer.yRotO + (entityplayer.yRot - entityplayer.yRotO) * f;
-        double d = entityplayer.xo + (entityplayer.x - entityplayer.xo) * (double)f;
-        double d1 = (entityplayer.yo + (entityplayer.y - entityplayer.yo) * (double)f + 1.62D) - (double)entityplayer.heightOffset;
-        double d2 = entityplayer.zo + (entityplayer.z - entityplayer.zo) * (double)f;
+        float f1 = player.xRotO + (player.xRot - player.xRotO) * f;
+        float f2 = player.yRotO + (player.yRot - player.yRotO) * f;
+        double d = player.xo + (player.x - player.xo) * (double)f;
+        double d1 = (player.yo + (player.y - player.yo) * (double)f + 1.62D) - (double)player.heightOffset;
+        double d2 = player.zo + (player.z - player.zo) * (double)f;
         Vec3 vec3 = Vec3.getTempVec3(d, d1, d2);
         float f3 = MathHelper.cos(-f2 * 0.01745329F - MathHelper.PI);
         float f4 = MathHelper.sin(-f2 * 0.01745329F - MathHelper.PI);
@@ -57,26 +58,26 @@ public class AlgaeBlockItem extends BlockItem
         }
         if(movingobjectposition.hitType == HitResult.HitType.TILE)
         {
-            int i = movingobjectposition.x;
-            int j = movingobjectposition.y;
-            int k = movingobjectposition.z;
+            int blockX = movingobjectposition.x;
+            int blockY = movingobjectposition.y;
+            int blockZ = movingobjectposition.z;
 
-            if(world.getBlockId(i, j, k) == Blocks.FLUID_WATER_STILL.id)
+            if(world.getBlockId(blockX, blockY, blockZ) == Blocks.FLUID_WATER_STILL.id)
             {
-                j++;
+                blockY++;
             }
             else{
                 return itemstack;
             }
 
-            if(world.getBlockId(i, j, k) != 0)
+            if(world.getBlockId(blockX, blockY, blockZ) != 0)
                 return itemstack;
             Block block = Block.blocksList[Blocks.ALGAE.id];
-            if(itemstack.consumeItem(entityplayer) && world.setBlockAndMetadataWithNotify(i, j, k, Blocks.ALGAE.id, 0))
+            if(itemstack.consumeItem(player) && world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.ALGAE.id, 0))
             {
-                block.onBlockPlacedByMob(world, i, j, k, null, entityplayer, 0.0);
-                world.playBlockSoundEffect(entityplayer, i + 0.5F, j + 0.5F, k + 0.5F, block, EnumBlockSoundEffectType.PLACE);
-                entityplayer.swingItem();
+                Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, Side.NONE, player, 0.0);
+                world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
+                player.swingItem();
             }
 
         }
diff --git a/src/main/java/net/minecraft/core/item/block/BlockItem.java b/src/main/java/net/minecraft/core/item/block/BlockItem.java
index 78fbdf5fc..73e3fa9a3 100644
--- a/src/main/java/net/minecraft/core/item/block/BlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/BlockItem.java
@@ -1,12 +1,18 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            Item, Block, World, ItemStack, 
@@ -30,7 +36,7 @@ public class BlockItem extends Item
     }
 
     @Override
-	public boolean onUseItemOnBlock(ItemStack stack, Player player, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack stack, @Nullable Player player, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
 		if(stack.stackSize <= 0) {
 			return false;
 		}
@@ -47,15 +53,30 @@ public class BlockItem extends Item
 			int meta = getPlacedBlockMetadata(player, stack, world, x, y, z, side, xPlaced, yPlaced);
 			if(world.setBlockAndMetadataWithNotify(x, y, z, blockID, meta)) {
 				stack.consumeItem(player);
-				block.onBlockPlacedByMob(world, x, y, z, side, player, yPlaced);
+				if (player == null) {
+                    block.onBlockPlacedByWorld(world, x, y, z);
+                } else {
+                    block.onBlockPlacedByMob(world, x, y, z, side, player, yPlaced);
+                }
 				world.playBlockSoundEffect(player, x + 0.5F, y + 0.5F, z + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				return true;
 			}
 		}
 		return false;
 	}
-    
-    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced)
+
+    @Override
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        int x = blockX + direction.getOffsetX();
+        int y = blockY + direction.getOffsetY();
+        int z = blockZ + direction.getOffsetZ();
+        Block b = world.getBlock(x, y, z);
+        if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
+            onUseItemOnBlock(itemStack, null, world, x, y, z, direction.getSide(), 0.5, 0.5);
+        }
+    }
+
+    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced)
     {
     	return Block.getBlock(blockID).getPlacedBlockMetadata(player, stack, world, x, y, z, side, xPlaced, yPlaced);
     }
diff --git a/src/main/java/net/minecraft/core/item/block/LadderBlockItem.java b/src/main/java/net/minecraft/core/item/block/LadderBlockItem.java
index 00858722e..8ab95f928 100644
--- a/src/main/java/net/minecraft/core/item/block/LadderBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/LadderBlockItem.java
@@ -7,6 +7,7 @@ import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public class LadderBlockItem extends BlockItem {
 
@@ -19,10 +20,10 @@ public class LadderBlockItem extends BlockItem {
 	}
 	
 	@Override
-	public boolean onUseItemOnBlock(ItemStack stack, Player player, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack stack, @Nullable Player player, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
 		Block clickedBlock = world.getBlock(x, y, z);
 		
-		if(clickedBlock == ladderBlock && !player.isSneaking()) {
+		if(clickedBlock == ladderBlock && player != null && !player.isSneaking()) {
 			Side clickedLadderSide = ladderBlock.getSideFromMeta(world.getBlockMetadata(x, y, z));
 			while(world.getBlock(x, y, z) == ladderBlock && ladderBlock.getSideFromMeta(world.getBlockMetadata(x, y, z)) == clickedLadderSide) y--;
 			int meta = ladderBlock.getMetaForSide(clickedLadderSide);
@@ -52,7 +53,7 @@ public class LadderBlockItem extends BlockItem {
 		return false;
 	}
 	
-	public boolean placeBlock(World world, int x, int y, int z, int meta, Player player, ItemStack stack, Side side, double sideHeight) {
+	public boolean placeBlock(World world, int x, int y, int z, int meta, @Nullable Player player, ItemStack stack, Side side, double sideHeight) {
 		if(world.canPlaceInsideBlock(x, y, z) && world.canBlockBePlacedAt(blockID, x, y, z, false, side) && stack.consumeItem(player)) {
 			if(world.setBlockAndMetadataWithNotify(x, y, z, blockID, meta)) {
 				Block.getBlock(blockID).onBlockPlacedByMob(world, x, y, z, side, player, sideHeight);
diff --git a/src/main/java/net/minecraft/core/item/block/LampBlockItem.java b/src/main/java/net/minecraft/core/item/block/LampBlockItem.java
index f088b21b4..5eb27fa99 100644
--- a/src/main/java/net/minecraft/core/item/block/LampBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/LampBlockItem.java
@@ -6,6 +6,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public class LampBlockItem extends BlockItem
 {
@@ -18,7 +19,7 @@ public class LampBlockItem extends BlockItem
     }
     
     @Override
-    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
     	return stack.getMetadata();
     }
 
diff --git a/src/main/java/net/minecraft/core/item/block/LayerBlockItem.java b/src/main/java/net/minecraft/core/item/block/LayerBlockItem.java
index 03a60d60e..49fa05fed 100644
--- a/src/main/java/net/minecraft/core/item/block/LayerBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/LayerBlockItem.java
@@ -14,6 +14,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 
 public class LayerBlockItem extends BlockItem
@@ -24,7 +25,7 @@ public class LayerBlockItem extends BlockItem
 	}
 
 	@Override
-	public boolean onUseItemOnBlock(final ItemStack itemstack, final Player entityplayer, final World world, int blockX, int blockY, int blockZ, final Side side, double xPlaced, final double yPlaced)
+	public boolean onUseItemOnBlock(final ItemStack itemstack, final @Nullable Player player, final World world, int blockX, int blockY, int blockZ, final Side side, double xPlaced, final double yPlaced)
 	{
 		int id = world.getBlockId(blockX, blockY, blockZ);
 		int meta = world.getBlockMetadata(blockX, blockY, blockZ);
@@ -71,8 +72,8 @@ public class LayerBlockItem extends BlockItem
 					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, blockID, 0);
 				}
 			}
-			world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockLayer, EnumBlockSoundEffectType.PLACE);
-			itemstack.consumeItem(entityplayer);
+			world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockLayer, EnumBlockSoundEffectType.PLACE);
+			itemstack.consumeItem(player);
 			return true;
 
 		}
@@ -116,8 +117,8 @@ public class LayerBlockItem extends BlockItem
 					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, blockID, 0);
 				}
 			}
-			world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockLayer, EnumBlockSoundEffectType.PLACE);
-			itemstack.consumeItem(entityplayer);
+			world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockLayer, EnumBlockSoundEffectType.PLACE);
+			itemstack.consumeItem(player);
 			return true;
 		}
 
@@ -125,12 +126,16 @@ public class LayerBlockItem extends BlockItem
 		if (world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
 		{
 			final Block block = Block.blocksList[blockID];
-			int placeMeta = getPlacedBlockMetadata(entityplayer, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+			int placeMeta = getPlacedBlockMetadata(player, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
 			{
-				Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, null, entityplayer, yPlaced);
-				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
-				itemstack.consumeItem(entityplayer);
+				if (player == null) {
+					Block.blocksList[blockID].onBlockPlacedByWorld(world, blockX, blockY, blockZ);
+				} else {
+					Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, Side.NONE, player, yPlaced);
+				}
+				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
+				itemstack.consumeItem(player);
 				return true;
 			}
 		}
diff --git a/src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java b/src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java
index 9179e3f21..86303dcf7 100644
--- a/src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java
@@ -11,6 +11,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public class LeavesLayerBlockItem extends BlockItem
 {
@@ -20,7 +21,7 @@ public class LeavesLayerBlockItem extends BlockItem
 	}
 
 	@Override
-	public boolean onUseItemOnBlock(final ItemStack itemstack, final Player entityplayer, final World world, int blockX, int blockY, int blockZ, final Side side, double xPlaced, final double yPlaced)
+	public boolean onUseItemOnBlock(final ItemStack itemstack, final Player player, final World world, int blockX, int blockY, int blockZ, final Side side, double xPlaced, final double yPlaced)
 	{
 		int id = world.getBlockId(blockX, blockY, blockZ);
 		int meta = world.getBlockMetadata(blockX, blockY, blockZ);
@@ -67,8 +68,8 @@ public class LeavesLayerBlockItem extends BlockItem
 					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, blockID, LeavesLayerBlock.setPermanent(0, true));
 				}
 			}
-			world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockLayer, EnumBlockSoundEffectType.PLACE);
-			itemstack.consumeItem(entityplayer);
+			world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockLayer, EnumBlockSoundEffectType.PLACE);
+			itemstack.consumeItem(player);
 			return true;
 
 		}
@@ -112,8 +113,8 @@ public class LeavesLayerBlockItem extends BlockItem
 					world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, blockID, LeavesLayerBlock.setPermanent(0, true));
 				}
 			}
-			world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockLayer, EnumBlockSoundEffectType.PLACE);
-			itemstack.consumeItem(entityplayer);
+			world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockLayer, EnumBlockSoundEffectType.PLACE);
+			itemstack.consumeItem(player);
 			return true;
 		}
 
@@ -121,12 +122,16 @@ public class LeavesLayerBlockItem extends BlockItem
 		if (world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
 		{
 			final Block block = Block.blocksList[blockID];
-			int placeMeta = getPlacedBlockMetadata(entityplayer, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+			int placeMeta = getPlacedBlockMetadata(player, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
 			{
-				Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, null, entityplayer, yPlaced);
-				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
-				itemstack.consumeItem(entityplayer);
+				if (player == null) {
+					Block.blocksList[blockID].onBlockPlacedByWorld(world, blockX, blockY, blockZ);
+				} else {
+					Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
+				}
+				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
+				itemstack.consumeItem(player);
 				return true;
 			}
 		}
@@ -135,7 +140,7 @@ public class LeavesLayerBlockItem extends BlockItem
 	}
 	
 	@Override
-	public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+	public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
 		return LeavesLayerBlock.MASK_PERMANENT;
 	}
 
diff --git a/src/main/java/net/minecraft/core/item/block/SlabBlockItem.java b/src/main/java/net/minecraft/core/item/block/SlabBlockItem.java
index cba832a33..27291fc9b 100644
--- a/src/main/java/net/minecraft/core/item/block/SlabBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/SlabBlockItem.java
@@ -8,6 +8,8 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
 public class SlabBlockItem extends BlockItem
 {
 
@@ -17,7 +19,7 @@ public class SlabBlockItem extends BlockItem
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
     	int id = world.getBlockId(blockX, blockY, blockZ);
     	int meta = world.getBlockMetadata(blockX, blockY, blockZ) & 0x3;
@@ -47,8 +49,8 @@ public class SlabBlockItem extends BlockItem
 
         		Block blockSlab = Block.blocksList[blockID];
         		world.setBlockMetadataWithNotify(blockX, blockY, blockZ, 1 | itemstack.getMetadata());
-                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockSlab, EnumBlockSoundEffectType.PLACE);
-            	itemstack.consumeItem(entityplayer);
+                world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockSlab, EnumBlockSoundEffectType.PLACE);
+            	itemstack.consumeItem(player);
             	return true;
         	}
         }
@@ -75,8 +77,8 @@ public class SlabBlockItem extends BlockItem
 
         		Block blockSlab = Block.blocksList[blockID];
         		world.setBlockMetadataWithNotify(blockX, blockY, blockZ, 1 | itemstack.getMetadata());
-                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockSlab, EnumBlockSoundEffectType.PLACE);
-                itemstack.consumeItem(entityplayer);
+                world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockSlab, EnumBlockSoundEffectType.PLACE);
+                itemstack.consumeItem(player);
             	return true;
         	}
         }
@@ -85,12 +87,16 @@ public class SlabBlockItem extends BlockItem
         if(world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
         {
             Block block = Block.blocksList[blockID];
-            int placeMeta = getPlacedBlockMetadata(entityplayer, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+            int placeMeta = getPlacedBlockMetadata(player, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
             if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
             {
-            	Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, entityplayer, yPlaced);
-                world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
-                itemstack.consumeItem(entityplayer);
+                if (player == null) {
+                    Block.blocksList[blockID].onBlockPlacedByWorld(world, blockX, blockY, blockZ);
+                } else {
+                    Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
+                }
+                world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
+                itemstack.consumeItem(player);
 				return true;
             }
         }
